//---------------------------------------------------
// module  : f_FPMSMCD.cc                       
// auteur  : Max Mignotte                           
// date    :                                              
// langage : C++                                      
// labo    : DIRO                                 
//---------------------------------------------------

//-----------------------------------------------
// FICHIERS INCLUS ------------------------------
//-----------------------------------------------
#include "FPMSMCD.h"

//------------------------------------------------
// METHODES DE LA CLASSE FPMSMCD ------------------
//------------------------------------------------
//----------------------------------------------------------
// FPMSMCD constructor 
//----------------------------------------------------------
FPMSMCD::FPMSMCD(float*** imgbef,float*** imgaft,float*** imggtr,int lgth,int wdth,char* NmImg,float MyPar)           
 {
  int i,j,k;

  //>Initialization
  length=lgth;
  width=wdth;
  strcpy(NameImg,NmImg);

  MyParam=MyPar;
  FlgSave=0;
  
  //>Memory_Allocation 
  MatImgBef=fmatrix_allocate_3d(TROIS,length,width);
  MatImgAft=fmatrix_allocate_3d(TROIS,length,width);
  MatImgGtr=fmatrix_allocate_3d(TROIS,length,width);
  MatImgSeg=fmatrix_allocate_3d(TROIS,length,width);
  MatImgCon=fmatrix_allocate_3d(TROIS,length,width);
  MatImgBefWB=fmatrix_allocate_2d(length,width);
  MatImgAftWB=fmatrix_allocate_2d(length,width);
  MatImgGtrWB=fmatrix_allocate_2d(length,width);
  MatImgSegWB=fmatrix_allocate_2d(length,width);
  MatImgIniWB=fmatrix_allocate_2d(length,width);

  MatImgTmp1=fmatrix_allocate_2d(length,width);
  MatImgTmp2=fmatrix_allocate_2d(length,width);
  MatImgTmp3=fmatrix_allocate_2d(length,width);
  MatImgTmp4=fmatrix_allocate_2d(length,width);

  //>Init_&_LoadMatrix
  for(k=0;k<TROIS;k++) for(i=0;i<length;i++) for(j=0;j<width;j++) 
     { MatImgBef[k][i][j]=imgbef[k][i][j];     
       MatImgAft[k][i][j]=imgaft[k][i][j];
       MatImgGtr[k][i][j]=imggtr[k][i][j];
       MatImgSeg[k][i][j]=0.0;
       MatImgCon[k][i][j]=0.0; }

  //>Flag_Color_Img
  FlgColorImgB=0;
  for(i=0;i<length;i++) for(j=0;j<width;j++) if (MatImgBef[1][i][j]!=MatImgBef[2][i][j]) { FlgColorImgB=1; }
  FlgColorImgA=0;
  for(i=0;i<length;i++) for(j=0;j<width;j++) if (MatImgAft[0][i][j]!=MatImgAft[2][i][j]) { FlgColorImgA=1; }
  if (FlgColorImgB) printf(" [Image_Before_In_Color]");
  if (FlgColorImgA) printf(" [Image_After_In_Color]");
  if ((FlgColorImgB==0)&&(FlgColorImgA==0)) printf(" [Image_Before_&_After_In_GreyScale]");
  printf("\n Parameters::[MyPar=%.3f]",MyPar);
  printf("\n");

  //>Color-GreyScale Conversion
  //---------------------------
  //>Average_based-Method 
  if (1)
  for(i=0;i<length;i++) for(j=0;j<width;j++)
    { MatImgBefWB[i][j]=((1.0/3.0)*MatImgBef[0][i][j])+((1.0/3.0)*MatImgBef[1][i][j])+((1.0/3.0)*MatImgBef[2][i][j]);
      MatImgAftWB[i][j]=((1.0/3.0)*MatImgAft[0][i][j])+((1.0/3.0)*MatImgAft[1][i][j])+((1.0/3.0)*MatImgAft[2][i][j]); }

  //>Luminosity_based-Method 
  if (0)
  for(i=0;i<length;i++) for(j=0;j<width;j++)
    { MatImgBefWB[i][j]=0.21*MatImgBef[0][i][j]+0.72*MatImgBef[1][i][j]+0.07*MatImgBef[2][i][j];
      MatImgAftWB[i][j]=0.21*MatImgAft[0][i][j]+0.72*MatImgAft[1][i][j]+0.07*MatImgAft[2][i][j]; }

  //>lightnesss_based-Method 
  if (0)
  for(i=0;i<length;i++) for(j=0;j<width;j++)
    { MatImgBefWB[i][j]=0.50*MAX(MAX(MatImgBef[0][i][j],MatImgBef[1][i][j]),MatImgBef[2][i][j]);
      MatImgBefWB[i][j]+=0.50*MIN(MIN(MatImgBef[0][i][j],MatImgBef[1][i][j]),MatImgBef[2][i][j]);
      MatImgAftWB[i][j]=0.50*MAX(MAX(MatImgAft[0][i][j],MatImgAft[1][i][j]),MatImgAft[2][i][j]);
      MatImgAftWB[i][j]+=0.50*MIN(MIN(MatImgAft[0][i][j],MatImgAft[1][i][j]),MatImgAft[2][i][j]); }

   for(i=0;i<length;i++) for(j=0;j<width;j++) MatImgIniWB[i][j]=0;
  				  
   for(i=0;i<length;i++) for(j=0;j<width;j++) MatImgGtrWB[i][j]=MatImgGtr[0][i][j];
   for(i=0;i<length;i++) for(j=0;j<width;j++) MatImgSegWB[i][j]=0;
  
   //>Verif->MatImgGtrWB
   k=0;
   for(i=0;i<length;i++) for(j=0;j<width;j++) if (!((MatImgGtrWB[i][j]==0)||(MatImgGtrWB[i][j]==255))) k++;
   if (k) { printf(" > Probleme: VeriteTerrain avec %d NonWhite || NonBlack pixels\n",k);
            fflush(stdout); }
 
 //Stack_Size_Increased_[128 MB]
 const rlim_t kStackSize=128*1024*1024;   
 struct rlimit rl;
 int result=getrlimit(RLIMIT_STACK,&rl);
 if (result==0)
 if (rl.rlim_cur<kStackSize)
    {  rl.rlim_cur=kStackSize;
       result=setrlimit(RLIMIT_STACK,&rl);
       if (result!=0) fprintf(stderr,"setrlimit returned result = %d\n",result); } 
 }

//----------------------------------------------------------
// FPMSMCD destructor
//----------------------------------------------------------
FPMSMCD::~FPMSMCD()
{ 
  //Memory_Liberation
  if (MatImgBef)  free_fmatrix_3d(MatImgBef,3);
  if (MatImgAft)  free_fmatrix_3d(MatImgAft,3);
  if (MatImgGtr)  free_fmatrix_3d(MatImgGtr,3);
  if (MatImgSeg)  free_fmatrix_3d(MatImgSeg,3);
  if (MatImgCon)  free_fmatrix_3d(MatImgCon,3);
  if (MatImgBefWB)  free_fmatrix_2d(MatImgBefWB);
  if (MatImgAftWB)  free_fmatrix_2d(MatImgAftWB);
  if (MatImgGtrWB)  free_fmatrix_2d(MatImgGtrWB);
  if (MatImgSegWB)  free_fmatrix_2d(MatImgSegWB);
  if (MatImgIniWB)  free_fmatrix_2d(MatImgIniWB);
  if (MatImgTmp1)   free_fmatrix_2d(MatImgTmp1);
  if (MatImgTmp2)   free_fmatrix_2d(MatImgTmp2);
  if (MatImgTmp3)   free_fmatrix_2d(MatImgTmp3);
  if (MatImgTmp4)   free_fmatrix_2d(MatImgTmp4);
}

//----------------------------------------------------------
//----------------------------------------------------------
// Multimodal Detection : <FRCT>
// ---------------------------------------------------------
//----------------------------------------------------------
void FPMSMCD::DetectionMCD_FRCT()
{
  int k;
  int nbreg;
  Chrono chrono;
  
  //>Model_Parameters
  int SZWNDIM;    
  //float SCALE;
  const int EPS=10;           
  const int KNN=5;            
  const int SIZEMINREG=600;  
  
  const float POURCSAT=0.0005; 
  const int NBGAUSSFILT=10;   

  const float HYPERPARAM=1.0; 
  const int NBITEREM=15; 
  const int NBCLASS=2;
  const int GAUSSIAN_LAW=1;

  //>MemoryAllocation_&_Init
  chrono.reset();
  float*** VctImgDif=fmatrix_allocate_3d(12,length,width);
  float**  ImgDifMean=fmatrix_allocate_2d(length,width);
  float** ImgHist=fmatrix_allocate_2d(256,256);
  float*  hyperpar=fmatrix_allocate_1d(NB_HYPERPAR);
  float** ppar=fmatrix_allocate_2d(NBCLASS,TROIS);
  
  for(k=0;k<NB_HYPERPAR;k++) hyperpar[k]=HYPERPARAM;
  InitZero(ImgDifMean,length,width);

  //>DiffMaps_Estimation_(SZWNDIM:8,16)_(SCALE:1,2,3)
  //-------------------------------------------------
  SZWNDIM=8;  //>8
  EstimFrctDiffMap(MatImgBefWB,MatImgAftWB,VctImgDif[0],length,width,SZWNDIM,2.0,KNN,EPS,POURCSAT);
  SZWNDIM=12; //>12
  EstimFrctDiffMap(MatImgBefWB,MatImgAftWB,VctImgDif[1],length,width,SZWNDIM,2.0,KNN,EPS,POURCSAT);
  SZWNDIM=16; //>16
  EstimFrctDiffMap(MatImgBefWB,MatImgAftWB,VctImgDif[2],length,width,SZWNDIM,2.0,KNN,EPS,POURCSAT);

  MeanMatrix(VctImgDif,length,width,3,ImgDifMean);
  //MeanMatrix(VctImgDif,length,width,1,ImgDifMean);
  //SaveImagePgm((char*)"",(char*)"_ImgDif",VctImgDif[0],length,width);
  GaussianFilter(ImgDifMean,length,width,NBGAUSSFILT); 
  //SaveImagePgm(InfoCD,(char*)"_Dif",ImgDifMean,length,width);
  

  //>Estimation-Segmentation_[Full-Resolution]
  //------------------------------------------
  ppar[0][0]=ppar[1][0]=0.5;
  ppar[0][2]=ppar[1][2]=100;
  ppar[0][1]=100;
  ppar[1][1]=200;

  //-ESTIMATION-STEP---
  //-For_Kmean
  //KmeanEstimate(ImgDifMean,length,width,NBCLASS,ppar,0,1);
  //-For_EM
  EM MyEm(NBCLASS,GAUSSIAN_LAW,length,width);
  MyEm.EM_Estimate(ImgDifMean,ppar,NBITEREM);
  //-For_SEM
  //SEM MySem(NBCLASS,GAUSSIAN_LAW,length,width);
  //MySem.SEM_Estimate(ImgDifMean,ppar,1,NBITEREM);
  //-For_ECI
  //ECI MyEci(NBCLASS,GAUSSIAN_LAW,length,width);
  //MyEci.ECI_Estimate(ImgDifMean,ppar,hyperpar,NBITEREM);
  ////FillPictHist(ImgHist,256,ImgDifMean,length,width,ppar);
  ////SaveImagePgm((char*)"",(char*)"_ImgHist",ImgHist,256,256);

  //-SEGMENTATION-STEP---
  //-For_ICM
  ICM MyIcm(NBCLASS,GAUSSIAN_LAW,length,width);
  (MyIcm).ICM_Estimate(ImgDifMean,ppar,hyperpar,MatImgSegWB); 
  //-For_MPM
  //MPM MyMpm(NBCLASS,GAUSSIAN_LAW,length,width);
  //MyMpm.MPM_Estimate(ImgDifMean,ppar,hyperpar,MatImgSegWB);
  //-For_ML
  //(MyIcm).ML_Estimate(ImgDifMean,ppar,MatImgSegWB);
  //-For_SMAP
  //const float ThetaPar=0.995;
  //const int SCALETREE=6;
  //SMAP MySmap(NBCLASS,GAUSSIAN_LAW,length,width,SCALETREE);         
  //MySmap.SMAP_Estimate(ImgDifMean,ppar,ThetaPar,2,MatImgSegWB);  

  //-END-STEP---
  FuseSmallRegions(MatImgSegWB,length,width,&nbreg,SIZEMINREG);
  Recal(MatImgSegWB,length,width);
  //SaveImagePgm((char*)"",(char*)"_ImgDifSeg",MatImgSegWB,length,width); 


  //>[Result_&_Save]
  //----------------
  printf("\n\n  _Result_Step_[%s]",NameImg);
  elptime=chrono.elapsed(SECOND);
  chrono.print();
  
  float* Result=fmatrix_allocate_1d(4);
  CopyMat(MatImgSeg,MatImgSegWB,length,width);
  ConfusionMatrix(MatImgCon,MatImgSegWB,MatImgGtrWB,length,width,Result);
  fmeasure=FMeasure(MatImgSegWB,MatImgGtrWB,length,width);
  precision=Precis(MatImgSegWB,MatImgGtrWB,length,width);
  
  sprintf(InfoCD,"%s_%sFRCT_K%d_R%d_Fm%.2f_Pr%.1f_Tm%d",NameImg,MyCom,KNN,SIZEMINREG,fmeasure,precision,elptime);
  printf("\n > FMeasure=%.3f  Precision=%.1f  (%s)",fmeasure,precision,InfoCD);

  //if (FlgSave)
     {
       SaveImagePgm(InfoCD,(char*)"_Dif",ImgDifMean,length,width);
       SaveImagePpm(InfoCD,(char*)"_SegConfus",MatImgCon,length,width);
       SaveImagePgm(InfoCD,(char*)"_SegResult",MatImgSegWB,length,width);
     }
  
  //>FreeMemory_&_END
  if (VctImgDif)  free_fmatrix_3d(VctImgDif,12);
  if (ImgDifMean) free_fmatrix_2d(ImgDifMean);
  if (ImgHist)    free_fmatrix_2d(ImgHist);
  if (hyperpar)   free_fmatrix_1d(hyperpar);
  if (ppar)       free_fmatrix_2d(ppar);
  if (Result)     free_fmatrix_1d(Result);
  printf("\n\n [END-]\n");
  fflush(stdout);
}
